#ifdef GL_ES
precision mediump int;
precision mediump float;
#endif

#define USE_OGRE_FROM_FUTURE
#include <OgreUnifiedShader.h>

SAMPLER2D(RT, 0);

OGRE_UNIFORMS(
uniform vec4 invTexSize;
uniform float blurRadius;
)

MAIN_PARAMETERS
IN(vec2 oUv0, TEXCOORD0)
MAIN_DECLARATION
{
  vec4 sum = vec4_splat(0.0);
	float blurSize = blurRadius * invTexSize.x;

	//X-blur.
	sum += texture2D(RT, vec2(oUv0.x - 4.0 * blurSize, oUv0.y)) * vec4_splat(0.04);
	sum += texture2D(RT, vec2(oUv0.x - 3.0 * blurSize, oUv0.y)) * vec4_splat(0.08);
	sum += texture2D(RT, vec2(oUv0.x - 2.0 * blurSize, oUv0.y)) * vec4_splat(0.12);
	sum += texture2D(RT, vec2(oUv0.x - blurSize, oUv0.y)) * vec4_splat(0.16);
	sum += texture2D(RT, oUv0) * vec4_splat(0.2);
	sum += texture2D(RT, vec2(oUv0.x + blurSize, oUv0.y)) * vec4_splat(0.16);
	sum += texture2D(RT, vec2(oUv0.x + 2.0 * blurSize, oUv0.y)) * vec4_splat(0.12);
	sum += texture2D(RT, vec2(oUv0.x + 3.0 * blurSize, oUv0.y)) * vec4_splat(0.08);
	sum += texture2D(RT, vec2(oUv0.x + 4.0 * blurSize, oUv0.y)) * vec4_splat(0.04);
  
  gl_FragColor = sum;
}
