
/** Tone mapping function 
@note Only affects rgb, not a
@param inColour The HDR colour
@param lum The scene lumninence 
@returns Tone mapped colour
*/
/*
vec4 toneMap(in vec4 inColour, in float lum)
{
  float MIDDLE_GREY = 0.72;
  float FUDGE = 0.001;
  float L_WHITE = 1.5;
  
	// From Reinhard et al
	// "Photographic Tone Reproduction for Digital Images"
	
	// Initial luminence scaling (equation 2)
    inColour.rgb *= vec3_splat(MIDDLE_GREY / (FUDGE + lum));

	// Control white out (equation 4 nom)
    inColour.rgb *= (vec3_splat(1.0) + inColour.rgb / vec3_splat(L_WHITE));

	// Final mapping (equation 4 denom)
	inColour.rgb /= (vec3_splat(1.0) + inColour.rgb);
	
	return inColour;
}
*/

vec4 toneMap(vec4 inColour, vec4 lum, vec4 key)
{  
  //Reinhard's Photographic Tone Reproduction Operator
  vec4 scaledlum = inColour * (key / (lum + vec4_splat(0.0001)));
  inColour.rgb = (scaledlum * (vec4_splat(1.0) + scaledlum / (lum + vec4_splat(0.0001) * lum + vec4_splat(0.0001))) / (vec4_splat(0.5) + scaledlum)).rgb;

	return saturate(inColour);
}